$(document).ready(function () {
    $('#btnClk').click(function () {
        var id = $("#metricQueryId").val();
        sendRequest({
            type: "POST",
            url: "/api/metric/list",
            data: JSON.stringify({id: id}),
            contentType: "application/json; charset=utf-8",
            dataType: "json"
        });
    });

    $('#btnProfiles').click(function () {
        var id = $("#profilesQueryId").val();

        sendRequest({
            type: "POST",
            url: "/api/profile/list",
            contentType: "application/json; charset=utf-8",
            data: JSON.stringify({id: id}),
            dataType: "json"
        });
    });

    $('#btnNodeList').click(function () {
        var id = $("#nodeId").val();

        sendRequest({
            type: "POST",
            url: "/api/node/list",
            data: JSON.stringify({id: id}),
            contentType: "application/json; charset=utf-8",
            dataType: "json"
        });
    });

    $('#btnNodeEdit').click(function () {
        var id = $("#editNodeId").val();
        var profiles = $("#editNodeProfiles").val();
        var profileList = profiles.split(",");
        sendRequest({
            type: "POST",
            url: "/api/node/update",
            data: JSON.stringify({id: id, profiles: profileList}),
            contentType: "application/json; charset=utf-8",
            dataType: "text"
        });
    });

    $('#btnNodeStatus').click(function () {
        var id = $("#statusNodeId").val();

        sendRequest({
            type: "POST",
            url: "/api/node_status/list",
            data: JSON.stringify({id: id}),
            contentType: "application/json; charset=utf-8",
            dataType: "json"
        });
    });

    $('#btnNodeCacheList').click(function () {
        var id = $("#nodeCacheId").val();
        var mediaId = $("#nodeCacheMediaId").val();
        var closed = $("#nodeCacheClosed").prop("checked");
        var nodeCacheNodeIp = $("#nodeCacheNodeIp").val();
        var nodeCacheNodeHostName = $("#nodeCacheNodeHostName").val();
        var nodeCacheStatus = $("#nodeCacheStatus").val();
        var nodeCacheName = $("#nodeCacheName").val();

        sendRequest({
            type: "POST",
            url: "/api/stream/list",
            data: JSON.stringify({
                node: id,
                mediaId: mediaId,
                name: nodeCacheName,
                status: nodeCacheStatus,
                showClosed: closed,
                nodeIp: nodeCacheNodeIp,
                nodeHostName: nodeCacheNodeHostName
            }),
            contentType: "application/json; charset=utf-8",
            dataType: "json"
        });
    });

    $('#btnNodeHistoryList').click(function () {
        var id = $("#nodeHistoryId").val();
        var mediaId = $("#nodeHistoryMediaId").val();
        var nodeHistoryNodeHostName = $("#nodeHistoryNodeHostName").val();
        var nodeHistoryNodeIp = $("#nodeHistoryNodeIp").val();
        var nodeHistoryName = $("#nodeHistoryName").val();
        var nodeHistoryPublisherId = $("#nodeHistoryPublisherId").val();
        var nodeHistoryStatus = $("#nodeHistoryStatus").val();

        sendRequest({
            type: "POST",
            url: "/api/stream/history",
            data: JSON.stringify({
                node: id,
                mediaId: mediaId,
                name: nodeHistoryName,
                publisher: nodeHistoryPublisherId,
                status: nodeHistoryStatus,
                nodeIp: nodeHistoryNodeIp,
                nodeHostName: nodeHistoryNodeHostName,
                limit: 30,
                offset: 0
            }),
            contentType: "application/json; charset=utf-8",
            dataType: "json"
        });
    });

    $('#btnNodeMetricList').click(function () {
        var id = $("#nodeMetricNodeId").val();
        var mediaId = $("#nodeMetricMediaId").val();
        sendRequest({
            type: "POST",
            url: "/api/stream/metrics",
            data: JSON.stringify({node: id, mediaId: mediaId, limit: 10, offset: 0}),
            contentType: "application/json; charset=utf-8",
            dataType: "json"
        });
    });

    $('#btnDeleteProfile').click(function () {
        var id = $("#deleteProfileId").val();
        sendRequest({
            type: "POST",
            url: "/api/profile/delete",
            data: JSON.stringify({id: id}),
            contentType: "application/json; charset=utf-8",
            dataType: "text"
        });
    });

    $('#btnNodeDelete').click(function () {
        var id = $("#deleteNodeId").val();
        sendRequest({
            type: "POST",
            url: "/api/node/delete",
            data: JSON.stringify({id: id}),
            contentType: "application/json; charset=utf-8",
            dataType: "text"
        });
    });

    $('#btnRuleDelete').click(function () {
        var id = $("#deleteRuleId").val();
        sendRequest({
            type: "POST",
            url: "/api/rule/delete",
            data: JSON.stringify({id: id}),
            contentType: "application/json; charset=utf-8",
            dataType: "text"
        });
    });

    $('#btnAlarmDelete').click(function () {
        var id = $("#deleteAlarmId").val();
        sendRequest({
            type: "POST",
            url: "/api/alarm/delete",
            data: JSON.stringify({id: id}),
            contentType: "application/json; charset=utf-8",
            dataType: "text"
        });
    });

    $('#btnAlarmEdit').click(function () {
        var id = $("#editAlarmId").val();
        var typeId = $("#editAlarmTypeId").val();
        var name = $("#editAlarmName").val();
        var value = $("#editAlarmValue").val();
        var metric = $("#editAlarmMetric").val();
        var node = $("#editAlarmNode").val();
        var time = $("#editAlarmTime").val();
        sendRequest({
            type: "POST",
            url: "/api/alarm/update",
            data: JSON.stringify({
                id: id,
                type: typeId,
                name: name,
                value: value,
                metric: metric,
                node: node,
                time: time
            }),
            contentType: "application/json; charset=utf-8",
            dataType: "text"
        });
    });

    $('#btnAlarmNew').click(function () {
        var id = $("#newAlarmId").val();
        var typeId = $("#newAlarmTypeId").val();
        var name = $("#newAlarmName").val();
        var value = $("#newAlarmValue").val();
        var metric = $("#newAlarmMetric").val();
        var node = $("#newAlarmNode").val();
        var time = $("#newAlarmTime").val();
        sendRequest({
            type: "POST",
            url: "/api/alarm/create",
            data: JSON.stringify({
                id: id,
                type: typeId,
                name: name,
                value: value,
                metric: metric,
                node: node,
                time: time
            }),
            contentType: "application/json; charset=utf-8",
            dataType: "text"
        });
    });

    $('#btnRuleEdit').click(function () {
        var id = $("#editRuleId").val();
        var typeId = $("#editRuleTypeId").val();
        var name = $("#editRuleName").val();
        var value = $("#editRuleValue").val();
        var profiles = $("#editRuleProfiles").val();
        var profileList = profiles.split(",");
        sendRequest({
            type: "POST",
            url: "/api/rule/update",
            data: JSON.stringify({
                id: id,
                type: typeId,
                name: name,
                value: value,
                profiles: profileList
            }),
            contentType: "application/json; charset=utf-8",
            dataType: "text"
        });
    });

    $('#btnRuleNew').click(function () {
        var typeId = $("#newRuleTypeId").val();
        var name = $("#newRuleName").val();
        var value = $("#newRuleValue").val();
        var profiles = $("#newRuleProfiles").val();
        var profileList = [];
        profiles.split(",").forEach(function (e) {
            profileList.push(e);
        });

        sendRequest({
            type: "POST",
            url: "/api/rule/create",
            data: JSON.stringify({
                type: typeId,
                name: name,
                value: value,
                profiles: profileList
            }),
            contentType: "application/json; charset=utf-8",
            dataType: "text"
        });
    });

    $('#btnProfileNew').click(function () {
        var metricList = $("#newProfileMetrics").val();
        var ruleList = $("#newProfileRules").val();
        var name = $("#newProfileName").val();
        var rate = $("#newProfileRate").val();

        var metrics = [];
        metricList.split(",").forEach(function (e) {
            metrics.push(e);
        });
        var rules = [];
        ruleList.split(",").forEach(function (e) {
            rules.push(e);
        });

        sendRequest({
            type: "POST",
            url: "/api/profile/create",
            data: JSON.stringify({
                name: name,
                rate: rate,
                metrics: metrics,
                rules: rules
            }),
            contentType: "application/json; charset=utf-8",
            dataType: "text"
        });
    });


    $('#btnRuleLoad').click(function () {
        var id = $("#editRuleId").val();
        sendRequest({
            type: "POST",
            url: "/api/rule/list",
            data: JSON.stringify({id: id, profileId: ''}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            filler: function (item) {
                $("#editRuleName").val(item.name);
                $("#editRuleValue").val(item.value);
                $("#editRuleTypeId").val(item.type);
                $("#editRuleProfiles").val(item.profiles);
            }
        });

    });

    $('#btnProfileLoad').click(function () {
        var id = $("#editProfileId").val();
        sendRequest({
            type: "POST",
            url: "/api/profile/list",
            contentType: "application/json; charset=utf-8",
            data: JSON.stringify({id: id}),
            dataType: "json",
            filler: function (item) {
                $("#editProfileRate").val(item.rate);
                $("#editProfileName").val(item.name);
                $("#editProfileRules").val(item.rules);
                $("#editProfileMetrics").val(item.metrics);
            }
        });
    });


    $('#btnNodeLoad').click(function () {
        var id = $("#editNodeId").val();
        sendRequest({
            type: "POST",
            contentType: "application/json; charset=utf-8",
            url: "/api/node/list",
            data: JSON.stringify({id: id}),
            dataType: "json",
            filler: function (item) {
                $("#editNodeIp").val(item.host);
                $("#editNodePort").val(item.port);
                $("#editNodeProfiles").val(item.profiles);
            }
        });
    });

    $('#btnAlarmLoad').click(function () {
        var id = $("#editAlarmId").val();
        sendRequest({
            type: "POST",
            contentType: "application/json; charset=utf-8",
            url: "/api/alarm/list",
            data: JSON.stringify({id: id}),
            dataType: "json",
            filler: function (item) {
                $("#editAlarmName").val(item.name);
                $("#editAlarmTime").val(item.time);
                $("#editAlarmValue").val(item.value);
                $("#editAlarmMetric").val(item.metric);
                $("#editAlarmTypeId").val(item.type);
                $("#editAlarmNode").val(item.node);
            }
        });
    });

    $('#btnProfileEdit').click(function () {
        var id = $("#editProfileId").val();
        var metricList = $("#editProfileMetrics").val();
        var ruleList = $("#editProfileRules").val();
        var name = $("#editProfileName").val();
        var rate = $("#editProfileRate").val();

        var metrics = [];
        metricList.split(",").forEach(function (e) {
            metrics.push(e);
        });
        var rules = [];
        ruleList.split(",").forEach(function (e) {
            rules.push(e);
        });

        sendRequest({
            type: "POST",
            url: "/api/profile/update",
            data: JSON.stringify({
                id: id,
                name: name,
                rate: rate,
                metrics: metrics,
                rules: rules
            }),
            contentType: "application/json; charset=utf-8",
            dataType: "text"
        });
    });

    $('#btnAlarmList').click(function () {
        var id = $("#alarmId").val();

        sendRequest({
            type: "POST",
            url: "/api/alarm/list",
            data: JSON.stringify({id: id}),
            contentType: "application/json; charset=utf-8",
            dataType: "json"
        });
    });

    $('#btnRuleList').click(function () {
        var ruleMediaId = $("#ruleId").val();
        var ruleProfile = $("#ruleProfileId").val();

        sendRequest({
            type: "POST",
            url: "/api/rule/list",
            data: JSON.stringify({id: ruleMediaId, profile: ruleProfile}),
            contentType: "application/json; charset=utf-8",
            dataType: "json"
        });
    });

    var wsType = window.location.protocol.replace(/:/g, '') == "https" ? "wss" : "ws";
    var client = Stomp.client(wsType + "://" + window.location.hostname + ":" + window.location.port + "/ws");
    client.connect({}, function () {
        client.subscribe("/alarms", function (msg) {
            msg.body = JSON.parse(msg.body);
            var el = $("<div>");
            el.html(syntaxHighlight(JSON.stringify(msg.body, null, 4)));
            $("#alarmPanel").append(el)
        });
    });

    var subscriptions = {};

    var closeSubscription = function (config) {
        id = config.client.id;
        config.client.unsubscribe();
        $("#" + id).remove();
        delete subscriptions[id];
    }

    var addToSubscriptionList = function (config) {
        subscriptions[config.id] = config;
        var row = "<tr id='" + config.client.id + "'><td>" + config.client.id + "</td><td>" + config.mediaId + "</td><td>" + config.nodeId + "</td><td><button id='button_" + config.client.id + "'>Close</button></td></tr>";
        $("#subscriptionList").append(row);
        $("#button_" + config.client.id).click(function () {
            closeSubscription(config);
        });
    }

    $('#btnWebSocket').click(function () {
        var mediaId = $("#stompMediaId").val();
        var nodeId = $("#stompNodeId").val();
        var display = window.open("chart-display.html");
        var c = client.subscribe("/stream/" + nodeId + "/" + mediaId, function (msg) {
            msg.body = JSON.parse(msg.body);
            $("#messageOut").html(syntaxHighlight(JSON.stringify(msg, null, 4)));
            if (display.hasOwnProperty("addData")) {
                display['addData'](msg.body);
            }
        });
        var config = {client: c, mediaId: mediaId, nodeId: nodeId, display: display};
        addToSubscriptionList(config);

        display.addEventListener("load", function () {
            display["init"](mediaId, metrics);
        });
    });
});